package asd.td3;

/**
 * Une classe pour l'exercice 2 de la feuille 3.
 * On crit rcursivement tous les mots  deux lettres contenant un
 * nombre particulier de chacune de ces lettres.
 *  2002 Marc Gatano
 */
public class Mots {

    private char x;
    private char y;

    /**
     * Construit un objet Mots.
     */
    public Mots(char x, char y) {
        this.x = x;
        this.y = y;
    }

    /**
     * Imprime a l'cran tous les mots forms de p 'x' et de q 'y'.
     * Complexit : THETA(C(p+q,p)) = THETA(C(p+q,q))
     */
    public void imprimer(int p, int q) {
        imprimer(p,q,"");
    }

    /**
     * Imprime a l'cran tous les mots forms de p 'x' et de q 'y' et avec
     * le prfixe s en plus.
     * Complexit : THETA(C(p+q,p)) = THETA(C(p+q,q))
     */
    private void imprimer(int p, int q, String s) {
        if ( p == 0 ) {
            if ( q == 0 ) {
                System.out.println(s);
            }
            else {
                imprimer(p,q-1,s + y);
            }
        }
        else {
            if ( q == 0 ) {
                imprimer(p-1,q,s + x);
            }
            else {
                imprimer(p,q-1,s + y);
                imprimer(p-1,q,s + x);
            }
        }
    }
}
